#ifndef BUTTON_HPP
#define BUTTON_HPP


#include<cstdint>




enum
KeyPressingID
{
  KEY_up    = 0x0001,
  KEY_down  = 0x0002,
  KEY_left  = 0x0004,
  KEY_right = 0x0008,
  KEY_p     = 0x0010,
  KEY_n     = 0x0020,
  KEY_space = 0x0040,
  KEY_shift = 0x0080,

};


enum
KeyModifiedID
{
  KEY_up_pressed      = 0x0001,
  KEY_up_unpressed    = 0x0002,
  KEY_down_pressed    = 0x0004,
  KEY_down_unpressed  = 0x0008,
  KEY_left_pressed    = 0x0010,
  KEY_left_unpressed  = 0x0020,
  KEY_right_pressed   = 0x0040,
  KEY_right_unpressed = 0x0080,
  KEY_p_pressed       = 0x0100,
  KEY_p_unpressed     = 0x0200,
  KEY_n_pressed       = 0x0400,
  KEY_n_unpressed     = 0x0800,
  KEY_space_pressed   = 0x1000,
  KEY_space_unpressed = 0x2000,
  KEY_shift_pressed   = 0x4000,
  KEY_shift_unpressed = 0x8000,

};


bool  test(KeyPressingID  id);
bool  test(KeyModifiedID  id);

void  clear_modified();

void    set(KeyPressingID  press_id, KeyModifiedID  modify_id);
void  unset(KeyPressingID  press_id, KeyModifiedID  modify_id);


#endif




