#include"group.hpp"




Group::
Group(ObjectUID  uid, const char16_t*  name):
Object(OBJ_group,uid,name)
{
}




MemberIndex
Group::
insert(Object*  obj)
{
  MemberIndex  i = MEMB_invalid;

    if(obj && (obj->get_group() != this))
    {
        if(empty_indexes.size())
        {
          i = empty_indexes.back();

          empty_indexes.pop_back();

          children[i] = obj;

          obj->set_group(this,i);
        }

      else
        {
          obj->set_group(this,children.size());

          children.emplace_back(obj);
        }
    }


  return i;
}


void
Group::
eject(MemberIndex  i)
{
    if(i < children.size())
    {
      empty_indexes.emplace_back(i);

      auto&  objptr = children[i];

      objptr->set_group(nullptr,MEMB_invalid);

      objptr = nullptr;
    }
}


void
Group::
update()
{
    for(auto  objptr: children)
    {
        if(objptr)
        {
          objptr->update();
        }
    }
}




