#ifndef OBJECT_HPP
#define OBJECT_HPP


#include"util.hpp"




class Object;


struct
ObjectCompare
{
  bool  operator()(const Object*  a, const Object*  b);

};


enum
ObjectGID: uint16_t
{
  OBJ_group,
  OBJ_human,
  OBJ_body,
  OBJ_place,

};


enum{
  MEMB_invalid = 0xFFFF,

  tile_size = 32,
};


using ObjectUID = uint16_t;
using MemberIndex = uint32_t;


class Group;


class
Object
{
protected:
  const char16_t*  name;

  Group*  group;

  MemberIndex  member_index;

public:
  const ObjectGID  object_gid;
  const ObjectUID  object_uid;

  Object(ObjectGID  gid, ObjectUID  uid=0, const char16_t*  _name=u"unnamed");

  virtual ~Object();


  void             set_name(const char16_t*  _name)      ;
  const char16_t*  get_name(                      ) const;

  void  set_group(Group*  grp, MemberIndex  i);

  Group*  get_group();

  MemberIndex  get_member_index() const;

  virtual void  update();

};




#endif




