#include"place.hpp"
#include"system.hpp"
#include"human.hpp"




Place::
Place(ObjectUID  uid, const char16_t*  name, int  w, int  h):
Object(OBJ_place,uid,name)
{
  resize(w,h);
}




PlaceElement&
Place::
get(int  x, int  y)
{
  return table[width*y+x];
}


const PlaceElement&
Place::
get(int  x, int  y) const
{
  return table[width*y+x];
}


void
Place::
reset()
{
    rep(y,height){
    rep(x,width ){
      auto&  l = get(x,y);

      l.point.x = x;
      l.point.y = y;

      l.place  = nullptr;
      l.object = nullptr;

      l.up    = ((y             )? &get(x  ,y-1):nullptr);
      l.left  = ((x             )? &get(x-1,y  ):nullptr);
      l.right = ((x < (width -1))? &get(x+1,y  ):nullptr);
      l.down  = ((y < (height-1))? &get(x  ,y+1):nullptr);
    }}
}


void
Place::
resize(int  w, int  h)
{
  table.resize(w*h);

  width  = w;
  height = h;

  reset();
}




void
Place::
join(Object&  obj)
{
//  tmpl_join(freed_human_indexes,humans,hum);
}




void
Place::
draw() const
{
  SDL_Rect  rect = {0,0,tile_size,tile_size};

    rep(y,height){
    rep(x, width){
rect.x=tile_size*x;
rect.y=tile_size*y;

if(get(x,y).object){SDL_SetRenderDrawColor(sys.renderer,0,0,0,0);}else
                   {SDL_SetRenderDrawColor(sys.renderer,255,255,255,255);}

SDL_RenderFillRect(sys.renderer,&rect);
    }}
}



void
Place::
update()
{
  human_group.update();
}




