#ifndef PLACE_HPP
#define PLACE_HPP


#include"group.hpp"
#include"shape_context.hpp"
#include<vector>




class Place;


struct
PlaceElement
{
  Place*  place;

  Object*  object;

  SDL_Point  point;

  PlaceElement*     up;
  PlaceElement*   down;
  PlaceElement*   left;
  PlaceElement*  right;

};


class
Place: public Object
{
  int   width;
  int  height;

  std::vector<PlaceElement>  table;

public:
  Group  human_group;
  Group  place_group;

  Place(ObjectUID  uid, const char16_t*  name, int  w, int  h);

  void  reset();
  void  resize(int  w, int  h);

        PlaceElement&  get(int  x, int  y)      ;
  const PlaceElement&  get(int  x, int  y) const;

  void  join(Object&  obj);

  void  draw() const;

  void  update();

};




#endif




