#ifndef SYSTEM_HPP
#define SYSTEM_HPP


#include"util.hpp"
#include"icon.hpp"
#include"place.hpp"
#include"human.hpp"
#include<vector>


class Human;


enum{
  screen_w = 640,
  screen_h = 480,
};


extern Place    world;
extern Player  player;


struct
System
{
  SDL_Texture*       texture;
  SDL_Texture*  icon_texture;

  SDL_Renderer*  renderer;

  std::vector<const Human*>  humans[screen_h/tile_size];

  Place*  current_place;

  int    looping_flag;
  int  streaming_flag;
  int  text_waiting_flag;

  System();

  void  draw();

  void  update_entries();

  void    lock_streaming();
  void  unlock_streaming();

};


extern System  sys;


#endif




