#include"text_area.hpp"
#include"system.hpp"
#include"print.hpp"
#include<unordered_map>
#include<deque>




namespace text{


namespace{


bool
streaming_flag;


struct
Line
{
  char16_t  string[79];

  char16_t*  it;

  Line*  next;

  Line(int  n, Line*  first): it(string), next(n? new Line(n-1,first):first){string[0] = 0;}


  void  push(int  c)
  {
    *it++ = c;
    *it   = 0;
  }


  void  clear()
  {
    it = string;

    *it = 0;
  }

};


enum{
  col_number = 32,
  row_number =  6,

  w = 16*(col_number+2),
  h = 16*(row_number+2),

};


SDL_Rect
rect = {32,screen_h-h,w,h};


std::unordered_map<uint32_t,std::u16string>  strings;


std::deque<char16_t>
buffer;


Line
lines(row_number-1,&lines);


int       x_pos;
int  line_index;


Line*   input = &lines;
Line*  output = &lines;


}


void
push_to_buffer(char16_t  c)
{
  buffer.push_back(c);
}


void
push_to_buffer(const char16_t*  s)
{
    while(*s)
    {
      buffer.push_back(*s++);
    }
}


size_t
get_buffer_remain()
{
  return buffer.size();
}


void
newline()
{
  input = input->next;

  x_pos = 0;

    if(++line_index >= row_number)
    {
      output->clear();

      output = output->next;

      line_index = (row_number-1);
    }
}


void
push_from_buffer()
{
    if(buffer.size() && clock())
    {
      auto  c = buffer.front();

      buffer.pop_front();

      push_direct(c);
    }
}


void
push_direct(char16_t  c)
{
    if(c == '\n')
    {
      newline();

      return;
    }


  input->push(c);
}


void
push_direct(const char16_t*  s)
{
    while(*s)
    {
      push_direct(*s++);
    }
}




void
draw()
{
    if(streaming_flag)
    {
      push_from_buffer();
    }


  Line*  ln = output;

  SDL_SetRenderDrawColor(sys.renderer,255,255,255,255);

  int  y = rect.y;

    rep(i,line_index+1)
    {
      print(ln->string,rect.x,y);

      y += 16;

      ln = ln->next;
    }
}



void
clear()
{
  line_index = 0;

   input = &lines;
  output = &lines;

  Line*  ln = &lines;

    rep(i,row_number)
    {
      ln->clear();

      ln = ln->next;
    }


  x_pos = 0;
}


void    set_streaming_flag(){streaming_flag =  true;}
void  unset_streaming_flag(){streaming_flag = false;}

bool  test_streaming_flag(){return streaming_flag;}


Clock
clock(80);


}




