#include"util.hpp"
#include"webpbuffer.hpp"
#include<random>




namespace{


std::random_device
seed_gen;


std::minstd_rand
engine(seed_gen());


}


int
report_count;


int
get_rand(int  min, int  max)
{
  std::uniform_int_distribution<>  dist(min,max);

  return dist(engine);
}




SDL_Texture*
load_texture(const char*  path, SDL_Renderer*  rend)
{
  enum{
    format = SDL_PIXELFORMAT_RGBA8888,
  };


  SDL_Texture*  texture;

  WebPBuffer  webp;

  webp.load(path);

  texture = SDL_CreateTexture(rend,format,SDL_TEXTUREACCESS_STATIC,webp.get_width(),webp.get_height());

  SDL_SetTextureBlendMode(texture,SDL_BLENDMODE_BLEND);

  std::vector<uint32_t>  tmpbuf(webp.get_width());

  auto  tmpfmt = SDL_AllocFormat(format);

    rep(y,webp.get_height())
    {
      SDL_Rect  rect = {0,y,webp.get_width(),1};

        rep(x,webp.get_width())
        {
          auto&  pix = webp.get_pixel(x,y);

          tmpbuf[x] = SDL_MapRGBA(tmpfmt,pix.r,pix.g,pix.b,pix.a);
        }


      SDL_UpdateTexture(texture,&rect,tmpbuf.data(),webp.get_width());
    }


  SDL_FreeFormat(tmpfmt);

  return texture;
}




