#ifndef UTIL_HPP
#define UTIL_HPP


#include<cstdint>
#include<cstdlib>
#include<cstdio>
#include<cstring>
#include<cstdarg>
#include<string>
#include<utility>
#include<SDL.h>


#define rep(v,n)  for(int  v = 0;  v < (n);  ++v)
#define report  printf("[%8d] file:%s func:%s line:%4d\n",report_count++,__FILE__,__func__,__LINE__)
#define printd(d)  printf("[%8d] %s:%8d\n",report_count++,#d,d)


template<typename  T>
constexpr unsigned int  make_flag(T  t){return(1<<t);}


extern int  report_count;


int  get_rand(int  min, int  max);

size_t   get_utf8_bytes(const char*  s);
size_t  get_utf8_length(const char*  s);
size_t  decode_utf8(const char*  s, char16_t&  c);
size_t  encode_to_utf8(char16_t  c, char*  buf, size_t  buf_size);

SDL_Texture*  load_texture(const char*  path, SDL_Renderer*  rend);


#endif




