#ifndef WEBPBUFFER_HPP
#define WEBPBUFFER_HPP


#include"util.hpp"
#include<vector>


class
WebPBuffer
{
public:
  struct Pixel{
    uint8_t  r;
    uint8_t  g;
    uint8_t  b;
    uint8_t  a;
  };


private:
  std::vector<Pixel>  pixels;

  int  w;
  int  h;

public:
  WebPBuffer(                 );
  WebPBuffer(WebPBuffer&&  rhs);


  void  swap(WebPBuffer&  rhs);

  int  get_width()  const;
  int  get_height() const;

  void  make( int  _w, int  _h);

        Pixel&  get_pixel(int  x, int  y)      ;
  const Pixel&  get_pixel(int  x, int  y) const;

  void  save(const char*  path, bool  lossless=false) const;
  void  load(const char*  path                      )      ;

};




#endif




